﻿:Namespace Minard
    WINDOWS←#.Util.InitCauseway ⎕THIS 

    ∇ LX;sp
      sp←Plot
      #.Util.View sp
      :If WINDOWS
          sp.SaveImage'MinardRevisited.png'System.Drawing.Imaging.ImageFormat.Png 256
      :EndIf
      sp.SaveSvg'MinardRevisited.svg'Causeway.SvgMode.FixedAspect
      ⎕←'Files saved to "',(,⎕SE.UCMD']cd'),'"'
    ∇


    MAPFILE←'MinardMap.jpg'

    ⍝ MAPEXTREMA[LONGITUDE LATITUDE;MININUM MAXIMUM]
    MAPEXTREMA←2 2⍴20 38 53.5 56.5

    ⍝ CITIES[NAME LONGITUDE LATITUDE;]
    CITIES←,[.5] 'Kowno'   'Wilna'   'Smorgoni'  'Molodexno'  'Gloubokoe'  'Minsk'   'Studienska'  'Polotzk'  'Bobr'    'Witebsk'  'Orscha'  'Mohilow'  'Smolensk'  'Dorogobouge'  'Wixma'   'Chjat'   'Mojaisk'  'Moscou'  'Tarantino'  'Malo-jarosewli'
    CITIES⍪←      24.0      25.3      26.4        26.8         27.7         27.6      28.5          28.7       29.2      30.2       30.4      30.4       32.0        33.2           34.3      34.4      36.0       37.6      36.6         36.5
    CITIES⍪←      55.0      54.7      54.4        54.3         55.2         53.9      54.3          55.5       54.4      55.3       54.5      53.9       54.8        54.9           55.2      55.5      55.5       55.8      55.3         55.0

    ⍝ TEMP[TEMPERATURE LONGITUDE DATE;]
    TEMP←,[.5]    0        0      ¯9       ¯21        ¯11        ¯20     ¯24         ¯30      ¯26
    TEMP⍪←       37.6     36.0    33.2      32.0       29.2       28.5    27.2        26.7     25.3
    TEMP⍪←  'Oct 18' 'Oct 24' 'Nov 9'  'Nov 14'   'Nov 24'   'Nov 28' 'Dec 1'     'Dec 6'  'Dec 7'

    ⍝ MARCH[DIVISION STATE SIZE LONGITUDE LATITUDE;]
    MARCH←,[.5]             1       1       1         1          1          1       1           1        1       1        1       1        1         1            1       1       1        1       1          1               1      1      1      1      1      1      1      2      2      2      2      2      2      2      2      2      2      2      2      2     2     2      3      3      3     3     3
    MARCH⍪←{1+'A'≠⍵~' '}'   A       A       A         A          A          A       A           A        A       A        A       A        A         A            A       R       R        R       R          R               R      R      R      R      R      R      R      A      A      A      A      A      R      R      R      R      R      R      R      R     R     R      A      A      R     R     R'
    MARCH⍪←            340000  340000  340000    320000     300000     280000  240000      210000   180000  175000   145000  140000   127100    100000       100000  100000   98000    97000   96000      87000           55000  37000  24000  20000  20000  20000  20000  60000  60000  60000  40000  33000  30000  30000  30000  28000  20000  12000  14000   8000  4000  4000  22000  22000   6000 10000 10000
    MARCH⍪←                24.0    24.5    25.5      26.0       27.0       28.0    28.5        29.0     30.0    30.3     32.0    33.2     34.4      35.5         36.0    37.6    37.5     37.0    36.8       35.4            34.3   33.3   32.0   30.4   29.2   28.5   28.3   24.0   24.5   25.5   26.6   27.4   28.7   29.2   28.5   28.3   27.5   26.8   26.4   24.6  24.4  24.2   24.0   24.5   24.6  24.2  24.1
    MARCH⍪←                54.9    55.0    54.5      54.7       54.8       54.9    55.0        55.1     55.2    55.3     54.8    54.9     55.5      55.4         55.5    55.8    55.7     55.0    55.0       55.3            55.2   54.8   54.6   54.4   54.4   54.3   54.4   55.1   55.2   54.7   55.7   55.6   55.5   54.3   54.2   54.3   54.5   54.3   54.4   54.5  54.4  54.4   55.2   55.3   55.8  54.4  54.3

    ∇ {sp}←SetAxisFonts sp
      sp.SetXCaptionFont'Times' 10 System.Drawing.FontStyle.Regular System.Drawing.Color.Navy
      sp.SetYCaptionFont'Times' 10 System.Drawing.FontStyle.Regular System.Drawing.Color.Navy
      sp.SetLabelFont'Times' 8 System.Drawing.FontStyle.Regular System.Drawing.Color.Black
    ∇

    ∇ {sp}←Plot;links;n;exp;split;width;height;top;bottom;left;right;state;div;mask;size;cities;lon;lat;temp;date;middletop;middlebottom
      (width height)←576 324
      (top bottom left right)←70 60 50 70
      middlebottom←height-middletop←220  ⍝ middle from top, middle from bottom
     
      ⍝ Set up page layout
      sp←⎕NEW Causeway.SharpPlot(width height)
      sp.Heading←'Napoleon’s march over Russia'
      sp.Footnote←'After M.Minard’s “Carte figurative des pertes successives en hommes de l’Armée Française dans la campagne de Russie 1812-1813”, Paris, 1869/11/20.'
      sp.SetFootnoteFont'Times' 8 System.Drawing.FontStyle.Italic System.Drawing.Color.Green
      sp.Gutter←0
      sp.SetMargins top middlebottom left right
      sp.XCaption←'Longitude (east)'
      sp.YCaption←'Latitude (north)'
      sp←SetAxisFonts sp
     
      ⍝ Draw geographical map beneath future plot
      sp.DrawImage MAPFILE MAPFILE(left)(top)(width-left+right)(height-top+middlebottom)
     
      ⍝ Set up axes
      sp.SetXRange MAPEXTREMA[1;] ⋄ sp.SetYRange MAPEXTREMA[2;]
      sp.XAxisStyle←Causeway.XAxisStyles.(Longitude+ExactFit+GridLines+OverlayGrid+TopAxis+CenteredCaption)
      sp.YAxisStyle←Causeway.YAxisStyles.(Latitude+ExactFit+GridLines+OverlayGrid+CenteredCaption)
      sp.SetAxisStyle 0 ⍝ no axis line
     
      ⍝ Compute NetowrkMap data
      (div state size lon lat)←↓MARCH ⋄ n←⊃⌽⍴MARCH
      exp←0,(¯1+n×n)⍴(n+1)↑1   ⍝ expansion mask for links to next node
      mask←(2=/div),1          ⍝ do not draw links across divisions
      links←n n⍴exp\¯1↓mask×size
      split←exp\¯1↓mask×state  ⍝ split links by advance/retreat
     
      ⍝ Add X Datum
      sp.SetXDatumLines 24
      sp.SetDatumLineTags⊂'Cosacks gallop across',(⎕UCS 10),'frozen Niemen.'
      sp.SetDatumTagFont'Times' 6 System.Drawing.FontStyle.Regular System.Drawing.Color.Black
     
      ⍝ Draw army as a NetworkMap
      sp.SetPenWidths 10
      sp.SetLineStyles Causeway.LineStyle.Solid
      sp.SetColors⊂System.Drawing.Color.(BurlyWood DarkGray)
      sp.SetValueFont'Arial' 6 System.Drawing.FontStyle.Bold System.Drawing.Color.Black
      sp.SetValueTags⊂,⌊0.5+links÷1000
      sp.SetNetworkMapLinkArc 0  ⍝ straight lines between nodes
      sp.NetworkMapStyle←Causeway.NetworkMapStyles.(FixedArcs+SplitByLink+NoMarkers+ValueTags)⍝+RoundLines)
      sp.SplitBy split('Advance' 'Retreat')  ⍝ implicitly sets the key
      sp.DrawNetworkMap(↓links)lon lat
     
      ⍝ Draw cities as a ScatterPlot, reusing axes
      (cities lon lat)←↓CITIES
      sp.SetMarkers Causeway.Marker.Bullet
      sp.SetColors System.Drawing.Color.Green
      sp.SetValueFont'Arial' 6 System.Drawing.FontStyle.Regular System.Drawing.Color.Green
      sp.SetValueTags⊂cities
      sp.ScatterPlotStyle←Causeway.ScatterPlotStyles.ValueTags
      sp.DrawScatterPlot lat lon
     
      ⍝ Set up new chart area for temperatures
      (temp lon date)←↓TEMP
      sp.ResetOption←Causeway.ResetOptions.SettingsPersist
      sp.NewFrame ⍬
      sp.Heading←sp.Footnote←''
      sp.XCaption←''
      sp.YCaption←'Temperature',(⎕UCS 10),'during retreat'
      sp←SetAxisFonts sp
      sp.SetMargins middletop bottom left right
     
      ⍝ Set up axes
      sp.SetYRange ¯30 0
      sp.XAxisStyle←Causeway.XAxisStyles.(Longitude+ExactFit+GridLines+OverlayGrid)
      sp.YAxisStyle←Causeway.YAxisStyles.(GridLines+OverlayGrid+Synchronised+RightAxis+CenteredCaption)
      sp.YLabelFormat←'##0°C'
     
      ⍝ Draw temperatures as a LineGraph
      sp.SetPenWidths 1.5
      sp.SetColors System.Drawing.Color.DarkGray  ⍝ LightSteelBlue
      sp.SetValueTags⊂date
      sp.SetValueFont'Arial' 6 System.Drawing.FontStyle.Regular System.Drawing.Color.Black
      sp.LineGraphStyle←Causeway.LineGraphStyles.ValueTags
      sp.ValueTagStyle←Causeway.ValueTagStyles.Vertical
      sp.SetValueNudge 3 0
      sp.DrawLineGraph temp lon
    ∇



:EndNamespace
