﻿:Namespace Wine
    WINDOWS←#.Util.InitCauseway ⎕THIS

    ∇ LX;sp;log
      Update ⍬ ⍝ 5 6 7
      sp←Plot
      #.Util.View sp
      :If WINDOWS
          sp.SaveImage'Wine.png'System.Drawing.Imaging.ImageFormat.Png 256
      :EndIf
      sp.SaveSvg'Wine.svg'Causeway.SvgMode.FixedAspect
      ⎕←'Files saved to "',(,⎕SE.UCMD']cd'),'"'
    ∇

    ∇ Update exclude;tie;txt;nl;mat;NumConv
      tie←'winequality-white.csv'⎕NTIE 0
      txt←'UTF-8'⎕UCS ⎕NREAD tie 83(⎕NSIZE tie)0
      ⎕NUNTIE tie
     
      nl←⎕UCS 10 ⋄ txt←¯1↓1↓¨(nl=txt)⊂txt←nl,txt  ⍝ cut at new line (first entry doesn't have it - last line is empty)
      txt←{1↓¨(';'=x)⊂x←';',⍵}¨txt       ⍝ cut deeper at ';' (first entry doesn't have it)
      mat←↑1↓txt                          ⍝ matrix[entry;attributes] - first line is titles
      mat←{
          (ok num)←⎕VFI ⍵
          ok≢,1:('Cannot convert : ',⍵)⎕SIGNAL 11
          ⊃num}¨mat
      mat←(~mat[;12]∊exclude)⌿mat
     
      FIXED_ACIDITY←mat[;1]                 ⍝  1 - fixed acidity
      VOLATILE_ACIDITY←mat[;2]              ⍝  2 - volatile acidity
      CITRIC←mat[;3]    ⍝  3 - citric acid
      SUGAR←mat[;4]     ⍝  4 - residual sugar
      CHLORIDES←mat[;5] ⍝  5 - chlorides
                  ⍝  6 - free sulfur dioxide
      SULFUR←mat[;7]    ⍝  7 - total sulfur dioxide
      DENSITY←mat[;8]   ⍝  8 - density
      PH←mat[;9]        ⍝  9 - pH
      SULPHATES←mat[;10]⍝ 10 - sulphates
      ALCOHOL←mat[;11]  ⍝ 11 - alcohol
      QUALITY←mat[;12]  ⍝ 12 - quality
      WINE←1    ⍝ flag for initialisation
    ∇

    ∇ sp←Plot
      sp←⎕NEW Causeway.SharpPlot
      sp.SetMargins 30 30 30 50 ⍝ Top Bottom Left Right
      sp.SetMarkers Causeway.Marker.Invisible
      ⍝sp.SetColors System.Drawing.Color.Black
      sp.SetValueFont'Arial' 5 System.Drawing.FontStyle.Regular System.Drawing.Color.Black
      sp.SetAltitudeColors⊂System.Drawing.Color.(Blue Green Yellow Red)
      sp.ContourPlotStyle←Causeway.ContourPlotStyles.(AltitudeShading+ScaleBar+ValueTags+Curves)
      sp.SetContourTagFont'Arial' 5 System.Drawing.FontStyle.Bold System.Drawing.Color.White
      sp.SetContourStyle System.Drawing.Color.Gray Causeway.LineStyle.Solid 0.5
      sp.Flexibility←100    ⍝ trend surface rather than modelfit
      sp.MeshDensity←1
      sp.Heading←'Wine Quality'
      sp.(XCaption YCaption ZCaption)←'Sugar' 'pH' 'Quality'
      sp.DrawContourPlot SUGAR PH QUALITY
    ∇

:EndNamespace